/*
 {bNX^IA\t  1Editorp}N
 :  

 RɕύXĂg

 1Editor͂
 http://park8.wakwak.com/~chin/
*/

using System;
using System.Drawing;
using System.Windows.Forms;

class Macro : Chin.EditorMacro
{
	public override object Main()
	{
		Form1 frm = new Form1(this);
		Editor.SetOwner(frm);
		if(Editor.WindowState == FormWindowState.Minimized){
			Editor.WindowState = FormWindowState.Normal;
		}
		frm.Show();

		return null;
	}
	
	internal int CurrentLineNumber{
		get{
			return Caret.CurrentLineNumber;
		}
	}
	internal int CurrentPosition{
		get{
			return Caret.CurrentPosition;
		}
	}
	internal int LineCount{
		get{
			return Document.LineCount;
		}
	}
	
	internal string GetLine(int line){
		return Document.GetLine(line);
	}
	internal void InsertText(string str){
		Document.InsertText(str);
	}
	internal void GoToPosition(int line, int pos){
		Caret.GoTo(line, pos);
	}
	internal void AddLine(){
		Document.InsertLine(Document.LineCount);
	}
}

class Form1 : System.Windows.Forms.Form
{
	private Macro _Macro;

	private System.Windows.Forms.Label label1;
	private System.Windows.Forms.Label label2;
	private System.Windows.Forms.Label label3;
	private System.Windows.Forms.Label label4;
	private System.Windows.Forms.Label label5;
	private System.Windows.Forms.Label label6;
	private System.Windows.Forms.Button button1;
	private System.Windows.Forms.Button button2;
	private System.Windows.Forms.Label label7;
	private System.Windows.Forms.TextBox textBoxStartLine;
	private System.Windows.Forms.TextBox textBoxEndLine;
	private System.Windows.Forms.TextBox textBoxStartPosition;
	private System.Windows.Forms.TextBox textBoxEndPosition;
	private System.Windows.Forms.Button buttonCopy;
	private System.Windows.Forms.Button buttonPaste;


	public Form1(Macro mac)
	{
		_Macro = mac;
		this.label1 = new System.Windows.Forms.Label();
		this.textBoxStartLine = new System.Windows.Forms.TextBox();
		this.label2 = new System.Windows.Forms.Label();
		this.textBoxStartPosition = new System.Windows.Forms.TextBox();
		this.label3 = new System.Windows.Forms.Label();
		this.label4 = new System.Windows.Forms.Label();
		this.textBoxEndPosition = new System.Windows.Forms.TextBox();
		this.textBoxEndLine = new System.Windows.Forms.TextBox();
		this.label5 = new System.Windows.Forms.Label();
		this.label6 = new System.Windows.Forms.Label();
		this.button1 = new System.Windows.Forms.Button();
		this.button2 = new System.Windows.Forms.Button();
		this.buttonCopy = new System.Windows.Forms.Button();
		this.buttonPaste = new System.Windows.Forms.Button();
		this.label7 = new System.Windows.Forms.Label();
		this.SuspendLayout();
		// 
		// label1
		// 
		this.label1.AutoSize = true;
		this.label1.Location = new System.Drawing.Point(32, 48);
		this.label1.Name = "label1";
		this.label1.Size = new System.Drawing.Size(54, 15);
		this.label1.TabIndex = 0;
		this.label1.Text = "Jnʒu";
		// 
		// textBoxStartLine
		// 
		this.textBoxStartLine.Location = new System.Drawing.Point(72, 69);
		this.textBoxStartLine.Name = "textBoxStartLine";
		this.textBoxStartLine.Size = new System.Drawing.Size(56, 19);
		this.textBoxStartLine.TabIndex = 0;
		this.textBoxStartLine.Text = "";
		// 
		// label2
		// 
		this.label2.AutoSize = true;
		this.label2.Location = new System.Drawing.Point(48, 72);
		this.label2.Name = "label2";
		this.label2.Size = new System.Drawing.Size(17, 15);
		this.label2.TabIndex = 0;
		this.label2.Text = "s";
		// 
		// textBoxStartPosition
		// 
		this.textBoxStartPosition.Location = new System.Drawing.Point(160, 69);
		this.textBoxStartPosition.Name = "textBoxStartPosition";
		this.textBoxStartPosition.Size = new System.Drawing.Size(56, 19);
		this.textBoxStartPosition.TabIndex = 1;
		this.textBoxStartPosition.Text = "";
		// 
		// label3
		// 
		this.label3.AutoSize = true;
		this.label3.Location = new System.Drawing.Point(136, 72);
		this.label3.Name = "label3";
		this.label3.Size = new System.Drawing.Size(17, 15);
		this.label3.TabIndex = 0;
		this.label3.Text = "";
		// 
		// label4
		// 
		this.label4.AutoSize = true;
		this.label4.Location = new System.Drawing.Point(32, 104);
		this.label4.Name = "label4";
		this.label4.Size = new System.Drawing.Size(54, 15);
		this.label4.TabIndex = 0;
		this.label4.Text = "Iʒu";
		// 
		// textBoxEndPosition
		// 
		this.textBoxEndPosition.Location = new System.Drawing.Point(160, 125);
		this.textBoxEndPosition.Name = "textBoxEndPosition";
		this.textBoxEndPosition.Size = new System.Drawing.Size(56, 19);
		this.textBoxEndPosition.TabIndex = 4;
		this.textBoxEndPosition.Text = "";
		// 
		// textBoxEndLine
		// 
		this.textBoxEndLine.Location = new System.Drawing.Point(72, 125);
		this.textBoxEndLine.Name = "textBoxEndLine";
		this.textBoxEndLine.Size = new System.Drawing.Size(56, 19);
		this.textBoxEndLine.TabIndex = 3;
		this.textBoxEndLine.Text = "";
		// 
		// label5
		// 
		this.label5.AutoSize = true;
		this.label5.Location = new System.Drawing.Point(136, 128);
		this.label5.Name = "label5";
		this.label5.Size = new System.Drawing.Size(17, 15);
		this.label5.TabIndex = 0;
		this.label5.Text = "";
		// 
		// label6
		// 
		this.label6.AutoSize = true;
		this.label6.Location = new System.Drawing.Point(48, 128);
		this.label6.Name = "label6";
		this.label6.Size = new System.Drawing.Size(17, 15);
		this.label6.TabIndex = 0;
		this.label6.Text = "s";
		// 
		// button1
		// 
		this.button1.Location = new System.Drawing.Point(224, 68);
		this.button1.Name = "button1";
		this.button1.Size = new System.Drawing.Size(68, 22);
		this.button1.TabIndex = 2;
		this.button1.Text = "ݒ";
		this.button1.Click += new System.EventHandler(this.button1_Click);
		// 
		// button2
		// 
		this.button2.Location = new System.Drawing.Point(224, 124);
		this.button2.Name = "button2";
		this.button2.Size = new System.Drawing.Size(68, 22);
		this.button2.TabIndex = 5;
		this.button2.Text = "ݒ";
		this.button2.Click += new System.EventHandler(this.button2_Click);
		// 
		// buttonCopy
		// 
		this.buttonCopy.Location = new System.Drawing.Point(64, 171);
		this.buttonCopy.Name = "buttonCopy";
		this.buttonCopy.Size = new System.Drawing.Size(176, 32);
		this.buttonCopy.TabIndex = 6;
		this.buttonCopy.Text = "BoxRs[s";
		this.buttonCopy.Click += new System.EventHandler(this.buttonCopy_Click);
		// 
		// buttonPaste
		// 
		this.buttonPaste.Location = new System.Drawing.Point(64, 210);
		this.buttonPaste.Name = "buttonPaste";
		this.buttonPaste.Size = new System.Drawing.Size(176, 32);
		this.buttonPaste.TabIndex = 7;
		this.buttonPaste.Text = "Box\ts(p)";
		this.buttonPaste.Click += new System.EventHandler(this.buttonPaste_Click);
		// 
		// label7
		// 
		this.label7.AutoSize = true;
		this.label7.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
		this.label7.ForeColor = System.Drawing.Color.CornflowerBlue;
		this.label7.Location = new System.Drawing.Point(16, 16);
		this.label7.Name = "label7";
		this.label7.Size = new System.Drawing.Size(251, 15);
		this.label7.TabIndex = 0;
		this.label7.Text = "JbgʒuɂĎݒ{^ƕ֗ł";
		// 
		// Form1
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
		this.ClientSize = new System.Drawing.Size(314, 256);
		this.Controls.Add(this.buttonCopy);
		this.Controls.Add(this.buttonPaste);
		this.Controls.Add(this.button1);
		this.Controls.Add(this.textBoxStartLine);
		this.Controls.Add(this.label1);
		this.Controls.Add(this.label2);
		this.Controls.Add(this.textBoxStartPosition);
		this.Controls.Add(this.label3);
		this.Controls.Add(this.label4);
		this.Controls.Add(this.textBoxEndPosition);
		this.Controls.Add(this.textBoxEndLine);
		this.Controls.Add(this.label5);
		this.Controls.Add(this.label6);
		this.Controls.Add(this.button2);
		this.Controls.Add(this.label7);
		this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
		this.MaximizeBox = false;
		this.MinimizeBox = false;
		this.Name = "Form1";
		this.ShowInTaskbar = false;
		this.Text = "BoxIA\t";
		this.Load += new System.EventHandler(this.Form1_Load);
		this.ResumeLayout(false);

	}

	private void Form1_Load(object sender, System.EventArgs e) {
		//	
	}

	private void button1_Click(object sender, System.EventArgs e) {
		textBoxStartLine.Text = _Macro.CurrentLineNumber.ToString();
		textBoxStartPosition.Text = _Macro.CurrentPosition.ToString();
	}

	private void button2_Click(object sender, System.EventArgs e) {
		textBoxEndLine.Text = _Macro.CurrentLineNumber.ToString();
		textBoxEndPosition.Text = _Macro.CurrentPosition.ToString();
	}

	private void buttonCopy_Click(object sender, System.EventArgs e) {
		//
		int StartLine, EndLine, StartPosition, EndPosition;
		try{
			StartLine = int.Parse(textBoxStartLine.Text);
		}
		catch(Exception exp){
			MessageBox.Show(this, "łȂ΂Ȃ܂", "BoxI");
			textBoxStartLine.Focus();
			return;
		}
		try{
			EndLine = int.Parse(textBoxEndLine.Text);
		}
		catch(Exception exp){
			MessageBox.Show(this, "łȂ΂Ȃ܂", "BoxI");
			textBoxEndLine.Focus();
			return;
		}
		try{
			StartPosition = int.Parse(textBoxStartPosition.Text);
		}
		catch(Exception exp){
			MessageBox.Show(this, "łȂ΂Ȃ܂", "BoxI");
			textBoxStartPosition.Focus();
			return;
		}
		try{
			EndPosition = int.Parse(textBoxEndPosition.Text);
		}
		catch(Exception exp){
			MessageBox.Show(this, "łȂ΂Ȃ܂", "BoxI");
			textBoxEndPosition.Focus();
			return;
		}

		if(EndPosition == StartPosition){
			// Rs[̂Ȃ
			return;
		}

		if(StartLine < 1 || StartLine > _Macro.LineCount){
			MessageBox.Show(this, "JnsCfbNXɂ܂", "BoxI");
			textBoxStartLine.Focus();
			return;
		}

		if(EndLine < 1 || EndLine > _Macro.LineCount){
			MessageBox.Show(this, "IsCfbNXɂ܂", "BoxI");
			textBoxEndLine.Focus();
			return;
		}

		if(StartPosition < 0 || StartPosition > _Macro.GetLine(StartLine).Length){
			MessageBox.Show(this, "JnCfbNXɂ܂", "BoxI");
			textBoxStartPosition.Focus();
			return;
		}

		if(EndPosition < 0 || EndPosition > _Macro.GetLine(EndLine).Length){
			MessageBox.Show(this, "ICfbNXɂ܂", "BoxI");
			textBoxEndPosition.Focus();
			return;
		}


		// Rs[
		
		if(EndLine == StartLine){
			if(EndPosition == StartPosition){
			// Rs[̂Ȃ
				return;
			}
			else if(EndPosition > StartPosition){
				Clipboard.SetDataObject(_Macro.GetLine(StartLine).Substring(StartPosition, EndPosition - StartPosition));
			}
			else if(EndPosition < StartPosition){
				Clipboard.SetDataObject(_Macro.GetLine(StartLine).Substring(EndPosition, StartPosition - EndPosition));
			}
		}
		else{
			int start, end, startPos, endPos;
			
			if(StartLine < EndLine){
				start = StartLine;
				end = EndLine;
			}
			else{
				start = EndLine;
				end = StartLine;
			}
			
			if(StartPosition < EndPosition){
				startPos = StartPosition;
				endPos = EndPosition;
			}
			else{
				startPos = EndPosition;
				endPos = StartPosition;
			}
			
			string buffer = "";
			for(int i=start; i<end; i++){ // ŌsOŏI
				if(_Macro.GetLine(i).Length >= endPos){
				//s
					buffer += _Macro.GetLine(i).Substring(startPos, endPos - startPos) + "\r\n";
				}
				else{
				// Ȃs͋󔒂Ŗ߂
					buffer += "".PadLeft(endPos - startPos, ' ') + "\r\n";
				}
			}
			//Ō̍s
			if(_Macro.GetLine(end).Length >= endPos){ //s
				buffer += _Macro.GetLine(end).Substring(startPos, endPos - startPos);
			}
			Clipboard.SetDataObject(buffer);
		}

	}

	private void buttonPaste_Click(object sender, System.EventArgs e) {
		string ClipboardStr = "";
		string[] buffer = null;
		int start = _Macro.CurrentLineNumber;
		int startPos = _Macro.CurrentPosition;
		
		if(Clipboard.GetDataObject().GetDataPresent(typeof(string)) == true){
		// Nbv{[hɂł߂ȃf[^(BoxRs[ĂȂf[^)ĂȂ\邪A
		// ܂Ń`FbNȂ
			
			ClipboardStr = (string)Clipboard.GetDataObject().GetData(typeof(string));
			buffer = ClipboardStr.Replace("\r", "").Split('\n');

			// ʂȕ̏ꍇA܂悭Ȃ
			for(int i=0; i<buffer.Length; i++){
				try{
					_Macro.GoToPosition(start + i, startPos);
				}
				catch(Exception exp){
					if((start + i) == _Macro.LineCount + 1){
						_Macro.AddLine();
					}
					else{
						_Macro.GoToPosition(start + i, _Macro.GetLine(start + i).Length);
					}
				}
				_Macro.InsertText(buffer[i]);
			}
		}
	}
}